From ab621a43505f25e3be16d4df1b8f828bc69b17cb Mon Sep 17 00:00:00 2001
From: Benjamin Dauvergne <bdauvergne@entrouvert.com>
Date: Mon, 21 Jul 2014 16:02:51 +0200
Subject: [PATCH 5/5] manager: l10n

---
 authentic2/manager/locale/fr/LC_MESSAGES/django.po |  182 ++++++++++++++++++++
 1 file changed, 182 insertions(+)
 create mode 100644 authentic2/manager/locale/fr/LC_MESSAGES/django.po

diff --git a/authentic2/manager/locale/fr/LC_MESSAGES/django.po b/authentic2/manager/locale/fr/LC_MESSAGES/django.po
new file mode 100644
index 0000000..8beca58
--- /dev/null
+++ b/authentic2/manager/locale/fr/LC_MESSAGES/django.po
@@ -0,0 +1,182 @@
+# Authentic2 manager l10n
+# Copyright (C) 2014 Entr'ouvert
+# This file is distributed under the same license as the authentic2 package.
+# Benjamin Dauvergne <bdauvergne@entoruvert.com>, 2014.
+#
+msgid ""
+msgstr ""
+"Project-Id-Version: entrouvert 2.1\n"
+"Report-Msgid-Bugs-To: \n"
+"POT-Creation-Date: 2014-08-13 14:52+0200\n"
+"PO-Revision-Date: 2014-08-13 14:53+0200\n"
+"Last-Translator: Benjamin Dauvergne <bdauvergne@entrouvert.com>\n"
+"Language-Team: French <fr@li.org>\n"
+"Language: \n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=2; plural=(n > 1);\n"
+
+#: forms.py:10
+msgid "Role name"
+msgstr "Nom du rôle"
+
+#: forms.py:17
+msgid "user"
+msgstr "utilisateur"
+
+#: tables.py:11
+msgid "username"
+msgstr "identifiant"
+
+#: tables.py:12
+msgid "Email"
+msgstr "Adresse électronique"
+
+#: tables.py:19
+msgid "None"
+msgstr ""
+
+#: views.py:114
+msgid "Add new role"
+msgstr "Ajouter un nouveau rôle"
+
+#: views.py:123
+msgid "Delete role"
+msgstr "Supprimer le rôle"
+
+#: views.py:130
+msgid "Edit role"
+msgstr "Éditer le rôle"
+
+#: views.py:165
+msgid "User already in this role"
+msgstr "L'utilisateurs a déjà ce rôle"
+
+#: views.py:204
+msgid "Create user"
+msgstr "Créer un nouvel utilisateur"
+
+#: views.py:205 templates/authentic2/manager/form.html:36
+msgid "Create"
+msgstr "Créer"
+
+#: views.py:209
+msgid "Edit user"
+msgstr "Éditer l'utilisateur"
+
+#: views.py:210 templates/authentic2/manager/roles.html:14
+msgid "Edit"
+msgstr "Éditer"
+
+#: views.py:214
+msgid "Reset password"
+msgstr "Ré-initialiser le mot de passe"
+
+#: views.py:216
+msgid "Deactivate"
+msgstr "Désactiver"
+
+#: views.py:218
+msgid "Activate"
+msgstr "Activer"
+
+#: views.py:220 templates/authentic2/manager/delete.html:18
+#: templates/authentic2/manager/roles.html:13
+msgid "Delete"
+msgstr "Supprimer"
+
+#: views.py:221
+#, python-format
+msgid "Do you really want to delete \"%s\" ?"
+msgstr "Souhaitez-vous vraiment supprimer \"%s\" ?"
+
+#: views.py:246
+#, python-format
+msgid "A mail was sent to %s"
+msgstr "Un courrier électronique a été envoyé à %s"
+
+#: templates/authentic2/manager/base.html:4
+#: templates/authentic2/manager/base.html:26
+msgid "Management"
+msgstr "Gestion"
+
+#: templates/authentic2/manager/delete.html:15
+#, python-format
+msgid "Do you want to delete role %(object)s ?"
+msgstr "Souhaitez-vous vraiment supprimer le rôle %(object)s ?"
+
+#: templates/authentic2/manager/delete.html:19
+#: templates/authentic2/manager/form.html:37
+msgid "Cancel"
+msgstr "Annuler"
+
+#: templates/authentic2/manager/form.html:25
+msgid "Actions"
+msgstr ""
+
+#: templates/authentic2/manager/homepage.html:8
+msgid "Welcome"
+msgstr "Bienvenue"
+
+#: templates/authentic2/manager/homepage.html:15
+msgid "Password change"
+msgstr "Changer le mot de passe"
+
+#: templates/authentic2/manager/homepage.html:19
+msgid "User management"
+msgstr "Gestion des utilisateurs"
+
+#: templates/authentic2/manager/homepage.html:20
+msgid "Role management"
+msgstr "Gestion des rôles"
+
+#: templates/authentic2/manager/role.html:12
+msgid "Users with role"
+msgstr "Utilisateurs ayant le rôle"
+
+#: templates/authentic2/manager/role.html:17
+msgid "Add an user to this role:"
+msgstr "Ajouter un utilisateur à ce rôle:"
+
+#: templates/authentic2/manager/role.html:20
+msgid "Add"
+msgstr "Ajouter"
+
+#: templates/authentic2/manager/role_users_table.html:9
+#, python-format
+msgid "Do you really want to delete user &quot;%(username)s&quot; ?"
+msgstr "Souhaitez-vous vraiment supprimer l'utilisateur &quot;%(username)s&quot; ?"
+
+#: templates/authentic2/manager/roles.html:4
+#: templates/authentic2/manager/roles.html:6
+msgid "Roles management"
+msgstr "Liste des rôles"
+
+#: templates/authentic2/manager/roles.html:16
+msgid "Add role"
+msgstr "Ajouter un rôle"
+
+#: templates/authentic2/manager/roles.html:36
+#: templates/authentic2/manager/roles.html:38
+#: templates/authentic2/manager/users.html:15
+#: templates/authentic2/manager/users.html:18
+msgid "Search"
+msgstr "Rechercher"
+
+#: templates/authentic2/manager/users.html:4
+#: templates/authentic2/manager/users.html:6
+msgid "Users management"
+msgstr "Liste des utilisateurs enregistrés"
+
+#: templates/authentic2/manager/users.html:10
+msgid "Add user"
+msgstr "Ajouter un utilisateur"
+
+#: vendor/gadjo/gadjo/templates/gadjo/base.html:35
+msgid "Logout"
+msgstr "Déconnexion"
+
+#: vendor/gadjo/gadjo/templates/gadjo/base.html:42
+msgid "Homepage"
+msgstr "Page d'accueil"
-- 
1.7.10.4